package org.greenstone.gsdl3.gs3build.expander;

import java.io.*;
import java.net.URL;
import java.util.*;

import org.greenstone.gsdl3.gs3build.BuildManager;

public class ZipExpander implements ExpanderInterface
{ BuildManager buildManager;

	public ZipExpander()
	{
	}

	public void configure(BuildManager manager)
	{	this.buildManager = manager;
	}

	public boolean expandFile(URL url, java.io.File expansionDirectory)
	{ if (url.toString().startsWith("file://")) 
		{	String fileName = url.toString().substring(7);

			if (fileName.endsWith(".zip"))
		  {	System.out.println("Expanding Zip file " + fileName);

				// determine which directory to use

				// get the leaf name
				String leafName;
				int leafAt = fileName.lastIndexOf(System.getProperty("file.separator"));
				
				if (leafAt >= 0)
				{ leafName = fileName.substring(leafAt+1);
				}
				else
				{	leafName = fileName;
				}

			  int extensionAt = leafName.lastIndexOf('.');
				if (extensionAt >= 0)
				{	leafName = leafName.substring(0, extensionAt);
				}

				File targetDir = new File(expansionDirectory, leafName);
				if (targetDir.exists())
				{	// find alternative name
					int  extension = 1;
					File expandedTarget;

					do
					{ expandedTarget = new File(targetDir.toString() + Integer.toString(extension));
					} while (expandedTarget.exists());

					targetDir = expandedTarget;
				}
				if (!targetDir.mkdir())
				{	// TODO: pass/log error - unable to make directory to
					//       expand file.
					return false;
				}

				// Call zip expansion
				try
				{
					Runtime.getRuntime().exec("unzip -d "+targetDir.toString());
				}
				catch (IOException io)
				{ // TODO: handle errors - report to log, etc.
					return false;
				}

				// ensure that the build manager knows about the new directory,
				// and will expand any content in it, etc. in turn
				this.buildManager.addInputDirectory(targetDir.toString());
				return true;
			}
		}
		return false;
	}
}